reShape.veg <- function (veg, crop = TRUE, refl) {
if(!'veg' %in% class(veg)) stop('Only applicable for objects of class \"veg\".')
if(is.null(attr(veg, 'taxreflist')) & missing(refl)) stop('Set option refl because attribute \"taxreflist\" is not set for object \"veg\".')
  plots <- as.integer(as.character(dimnames(veg)[[1]][row(veg)]))
  veg <- as.matrix(veg)
  perf <- as.vector(veg)
  spec <- dimnames(veg)[[2]][col(veg)]
  
  spcnames <- sapply(spec, function(x) strsplit(as.character(x), '.', fixed=TRUE))
  layer <- factor(unlist(lapply(spcnames, function(x) x[2])))
  levels(layer) <- c(levels(layer),'0')
  layer <- as.integer(layer)
  layer[is.na(layer)] <- 0

  lettercode <- unlist(lapply(spcnames, function(x) x[1]))
  TaxonUsageID <- integer(length(lettercode))
  taxa <- tax(lettercode, syn=FALSE)
  TaxonUsageID <- taxa$TaxonUsageID[match(lettercode, taxa$LETTERCODE)]

  # o <- df[order(df[,1], df[,2]),]
  # df <- df[o,]
  perc <- if(is.numeric(perf)) as.integer(perf) else NA
  df <- data.frame(RELEVE_NR = plots, SPECIES_NR = TaxonUsageID, COVER_CODE=as.character(perf), LAYER = layer, COVER_PERC = perc)
  df <- df[order(df$RELEVE_NR, df$SPECIES_NR),]
  if(crop) df <- df[df$COVER_PERC!=0,]
  
  class(df)<- c('tv.obs', 'data.frame')
  if(!is.null(attr(veg, 'taxreflist'))) attr(df, 'taxreflist') <- attr(veg, 'taxreflist')
  return(df)
}
